Package ch.qos.logback.classic.spi

## Class CallerData

- java.lang.Object
- - ch.qos.logback.classic.spi.CallerData

    public class CallerData
    extends java.lang.Object

This class computes caller data returning the result in the form of a StackTraceElement array.

Author:
  Ceki Gülcü

### Field Summary

Fields
`static java.lang.String` `CALLER_DATA_NA`
`static java.lang.StackTraceElement[]` `EMPTY_CALLER_DATA_ARRAY` This value is returned in case no caller data could be extracted.
`static int` `LINE_NA` When caller information is not available this constant is used for the line number.
`static java.lang.String` `NA` When caller information is not available this constant is used for file name, method name, etc.

### Constructor Summary

Constructors
`CallerData()`

### Method Summary

All Methods Static Methods Concrete Methods
`static java.lang.StackTraceElement[]` `extract​(java.lang.Throwable t, java.lang.String fqnOfInvokingClass, int maxDepth, java.util.List<java.lang.String> frameworkPackageList)` Extract caller data information as an array based on a Throwable passed as parameter
`static java.lang.StackTraceElement` `naInstance()` Returns a StackTraceElement where all string fields are set to `NA` and line number is set to `LINE_NA`.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### NA

    public static final java.lang.String NA

When caller information is not available this constant is used for file name, method name, etc.

See Also:
  Constant Field Values

#### LINE_NA

    public static final int LINE_NA

When caller information is not available this constant is used for the line number.

See Also:
  Constant Field Values

#### CALLER_DATA_NA

    public static final java.lang.String CALLER_DATA_NA

#### EMPTY_CALLER_DATA_ARRAY

    public static final java.lang.StackTraceElement[] EMPTY_CALLER_DATA_ARRAY

This value is returned in case no caller data could be extracted.

### Constructor Detail

#### CallerData

    public CallerData()

### Method Detail

#### extract

    public static java.lang.StackTraceElement[] extract​(java.lang.Throwable t,
                                                        java.lang.String fqnOfInvokingClass,
                                                        int maxDepth,
                                                        java.util.List<java.lang.String> frameworkPackageList)

Extract caller data information as an array based on a Throwable passed as parameter

#### naInstance

    public static java.lang.StackTraceElement naInstance()

Returns a StackTraceElement where all string fields are set to `NA` and line number is set to `LINE_NA`.

Returns:
  StackTraceElement with values set to NA constants.
Since:
  1.0.10